<script>
    import { scale } from 'svelte/transition'
    import Logout from './Icons/Logout.svelte'
    import { user } from 'store'

    let show = false

    const init = node => {
        const handleClickOutside = event => {
            if (show && !node.contains(event.target)) {
                show = false
            }
        }

        document.addEventListener('click', handleClickOutside, false)

        return {
            destroy: () => {
                document.removeEventListener('click', handleClickOutside, false)
            },
        }
    }

    const logout = async () => {
        localStorage.clear()
        user.set(undefined)
    }
</script>

<div class="menu-container" use:init>
    <button id="menu-button" on:click={() => (show = !show)}>
        <span>Gérer mon compte</span>
    </button>

    {#if show}
        <div
            id="menu"
            in:scale={{ duration: 100, start: 0.95 }}
            out:scale={{ duration: 75, start: 0.95 }}
        >
            <a href="/parametres/profil">Modifier mon profil</a>
            <a href="/parametres/mot-de-passe">Changer de mot de passe</a>
            <hr />
            <button id="logout" on:click={logout}>
                <Logout />
                Se déconnecter
            </button>
        </div>
    {/if}
</div>

<style lang="postcss">
    .menu-container {
        @apply relative;

        #menu-button {
            @apply py-1 px-2 border-2 border-teal-500 text-teal-500 rounded-full mb-2;

            span {
                @apply mx-auto;
            }
        }

        #menu {
            @apply absolute origin-top-right right-0 flex flex-col bg-white border border-blueGray-100 shadow-lg rounded-xl w-56 py-2 z-20;

            button,
            a {
                @apply block text-left px-4 text-blueGray-700 py-1 leading-snug;

                &:hover {
                    @apply bg-blueGray-100;
                }
            }

            #logout {
                @apply flex items-center text-left px-4 py-1 leading-snug gap-x-2 text-red-500;

                &:hover {
                    @apply bg-red-100;
                }
            }

            hr {
                @apply mt-2 pb-2;
            }
        }
    }
</style>
